# Transformamos el circulo unitario según una homografía
#
# Fraga, 30.06.2022
import sys
import numpy as np

n = len( sys.argv )
if n != 4 :
	print("cx cy cz")
	sys.exit(1)

cx = float( sys.argv[1] )
cy = float( sys.argv[2] )
cz = float( sys.argv[3] )


# Un circulo de radio 1 
C1 = np.eye( 3 )
C1[2,2] = -1.0

# La cámara, f=1000,
#  y el punto principal en (300,200) 
#
K = np.array( [[ 1000.0,    0.0, -300.0],
               [    0.0, 1000.0, -200.0],
               [    0.0,    0.0,   -1.0 ] ] );

# El modelo de la cámara obscura
# lp = K R[ I| -c] P 
# lp = H P

# Leemos R del archivo R.bin
try:
	R = np.fromfile( "R.bin" )
	R = R.reshape( (3,3) )
except:
	print("No puedo leer el archivo R.bin")
	sys.exit(2)

M = np.eye( 3 );
M[0,2]  = -cx;
M[1,2]  = -cy;
M[2,2]  = -cz;

H = K @ R @ M
Hinv = np.linalg.inv( H )

# La elipse 1
E1 = 1000.0 * (Hinv.T @ C1 @ Hinv)
print( E1 )
E1.tofile( "E1.bin" )

